#include "../ThemeEndianness.h"
#include <Carbon/Carbon.h>

bool 
LogFormat(ThemeDataFormat inFormat)
{
    switch (inFormat) {
        case kThemeDataFormatUnknown:
            printf("kThemeDataFormatUnknown\n");
            break;
        case kThemeDataBigEndian:
            printf("kThemeDataBigEndian\n");
            break;
        case kThemeDataLittleEndian:
            printf("kThemeDataLittleEndian\n");
            break;
    }
    return true;
}


void 
LogThemeDataFormatForPath(CFStringRef inPath)
{
    ThemeDataFormat format;
    ThemeDataError  error;
    HFSUniStr255    dataForkName;
    bool            haveLogged = false;
    
    // bad form, but it's sample code
    printf("path: %s, status: ", CFStringGetCStringPtr(inPath, kCFStringEncodingMacRoman));    

    error = ThemeDataFormatForPath(inPath, &format);
    if ( kThemeDataNoError == error && kThemeDataFormatUnknown != format )
        haveLogged = LogFormat(format);
    else
    {
        OSErr theErr = FSGetDataForkName ( &dataForkName );
        if ( noErr == theErr )
        {
            CFURLRef url = CFURLCreateWithFileSystemPath(kCFAllocatorDefault, inPath, kCFURLPOSIXPathStyle, FALSE);
            if ( url )
            {
                FSRef fsRef;
                if( CFURLGetFSRef(url, &fsRef) )
                {
                    SInt16 refNum;
                    theErr = FSOpenResourceFile ( &fsRef, dataForkName.length, dataForkName.unicode, fsCurPerm, &refNum);
                    if ( noErr == theErr )
                    {
                        error = ThemeDataFormatForResourceFile(refNum, &format);
                        if ( kThemeDataNoError == error )
                            haveLogged = LogFormat(format);
                        FSCloseFork(refNum);
                    }
                }
                CFRelease(url);
            }
        }
    }
    
    if ( ! haveLogged )
        printf("<error>\n");
}


int 
main (int argc, const char * argv[])
{
    LogThemeDataFormatForPath(CFSTR("./little.rsrc"));
    LogThemeDataFormatForPath(CFSTR("./big.rsrc"));
    LogThemeDataFormatForPath(CFSTR("/System/Library/Frameworks/Carbon.framework/Frameworks/HIToolbox.framework/Resources/Extras.rsrc"));
    LogThemeDataFormatForPath(CFSTR("/System/Library/Frameworks/Carbon.framework/Frameworks/HIToolbox.framework/Resources/Extras2.rsrc"));
    return 0;
}
